#

import RPi.GPIO as GPIO
GPIO.setwarnings (False)
import time
global r # aggiunto

try:
    from Tkinter import *
    from Tkinter import ttk
    from Tkinter import messagebox

except:
    from tkinter import *
    from tkinter import ttk
    from tkinter import messagebox


class LED():
  pass
  # Definizione dei Led


led = LED()

led.l1 = 18
led.l2 = 23
led.l3 = 24
led.l4 = 25
led.l5 = 4


class DATI_TAGLIO():
  pass
  # Definizione delle variabili per il taglio

dt = DATI_TAGLIO()

dt.lung_cavo = 0
dt.num_tagli = 0
dt.adj = 0
dt.in_lung_cavo = 0
dt.in_num_tagli = 0
dt.in_adj = 0

class CONTROLLO_MOTORE():
  pass
  #Definizione delle variabili per il controllo del motore

cm = CONTROLLO_MOTORE()
cm.rampa = 1050
cm.step_mm = 6.37
cm.step_totali = 0



GPIO.setmode(GPIO.BCM)
GPIO.setup(led.l1,GPIO.OUT)
GPIO.setup(led.l2,GPIO.OUT)
GPIO.setup(led.l3,GPIO.OUT)
GPIO.setup(led.l4,GPIO.OUT)
GPIO.setup(led.l5,GPIO.OUT)

GPIO.output (led.l1,GPIO.LOW)
GPIO.output (led.l2,GPIO.LOW)
GPIO.output (led.l3,GPIO.LOW)
GPIO.output (led.l4,GPIO.LOW)
GPIO.output (led.l5,GPIO.LOW)


def cancella_1():
    dt.in_lung_cavo.set('0')
    i1 = Spinbox(radice , width = 5 ,font = 40, from_ = 50, to = 1000 , increment = 5 , textvariable=dt.in_lung_cavo , bd = 2).place(x = 150 , y = 69)

def cancella_2():
    dt.in_num_tagli.set('0')
    i2 = Spinbox(radice , width = 5 ,font = 40, from_ = 1, to = 100 , increment = 5 , textvariable=dt.in_num_tagli , bd = 2).place(x = 150 , y = 119)
       
def chiama_about():
    messagebox.showinfo(title = "About" , message = "La mia finestra CNC 2.0")
    

def uscita():
    risposta = messagebox.askyesno(title = "Uscita" , message = "Vuoi davvero uscire ?")
    if risposta:
        radice.destroy()

def Step (pin):

        GPIO.output(pin,GPIO.HIGH)
        time.sleep (0.00012)        
        GPIO.output(pin,GPIO.LOW)
        Pausa (cm.rampa)

	
def Pausa (us):
        tempo = (1/1100000)*us
        time.sleep (tempo)
        return
    

def estrai():

    dt.lung_cavo = int (dt.in_lung_cavo.get())
    dt.num_tagli = dt.in_num_tagli.get()
    dt.adj = dt.in_adj.get()
    cm.step_totali = (dt.lung_cavo * cm.step_mm) + dt.adj
    
    print (cm.step_totali)
    print (dt.num_tagli)
    print (dt.adj)
    
    ciclo()


def avanza():

    i = 0

    for i in range (1,int (cm.step_totali)):
        Step (led.l1)
        
        if (i < 375):
          cm.rampa = cm.rampa - 2
          
		
        if (i > cm.step_totali - 375):
          cm.rampa = cm.rampa + 2          

            

def ciclo():
    global r
    for c in range (0,dt.num_tagli):
        time.sleep (1)
        r= dt.num_tagli - c # aggiunto
        print (r) # avanza()
        l5=Label(radice,text = r ,width ="5",bg="yellow",font = "Times 14 normal").place(x=410, y=197) # aggiunto
        avanza()#aggiunto
    return

def chiama_setup():
    settaggi=Tk()
    settaggi.geometry('400x300+500+200')
    settaggi.title("Pippo snc - Settaggi")

    Label(settaggi,text ="Settaggi",width ="20",font = 50,bg = "green").place(x=150 , y=10)
    conferma1 = Button(settaggi , text ="Prova" ,width="15", bg="yellow",command = estrai).place(x = 150, y = 200)
    conferma2 = Button(settaggi , text ="Seconf Windows" ,width="15", bg="brown",command = estrai).place(x = 150, y = 240)

    settaggi.mainloop()
		
	
radice=Tk()
radice.geometry('500x400+500+200')
radice.title("Pippo snc")

# ------------------------------------------
barra_menu = Menu(radice)
# Creo Menu File
menu_file = Menu(barra_menu , tearoff = 0)
barra_menu.add_cascade(label = "File" , menu = menu_file)
menu_file.add_command(label = "Nuovo")
menu_file.add_command(label = "Modifica")
menu_file.add_command(label = "Esci" , command = uscita)
# Creo Menu Configura
menu_configura = Menu(barra_menu , tearoff = 0)
barra_menu.add_cascade(label = "Configura" , menu = menu_configura)
menu_configura.add_command(label = "Settaggi", command = chiama_setup)
# Creo Menu About
menu_about = Menu(barra_menu,tearoff=0)
barra_menu.add_cascade(label = "About" , menu = menu_about)
menu_about.add_command(label = "About" , command = chiama_about)

radice.config(menu = barra_menu)
# -------------------------------------------

dt.in_lung_cavo = IntVar()
dt.in_num_tagli = IntVar()
dt.in_adj = IntVar()
r = IntVar() # aggiunto
r=0  # aggiunto

Label(radice,text ="Taglierina",width ="20",font = 50,bg = "green").place(x=150 , y=10)

l1 = Label(radice,text = "Lunghezza Taglio : ",width="15",bg = "white").place(x=15 , y=73)
l2 = Label(radice,text = "N° Pezzi : ",width="15",bg = "white").place(x=15 , y=123)
l3 = Label(radice,text = "Correzzione mm. : ",width="15",bg = "white").place(x=15 , y=173)

i1 = Spinbox(radice , width = 5 ,font = 40, from_ = 50, to = 1000 , increment = 5 , textvariable=dt.in_lung_cavo, bd = 2).place(x = 150 , y = 69) 

i2 = Spinbox(radice , width = 5 , font = 40,from_ = 1, to = 100 , increment = 1 , textvariable=dt.in_num_tagli, bd = 2).place(x = 150 , y = 119) 

i3 = Spinbox(radice , width = 5 , font = 40,from_ = -5, to = 5 , increment = 1 , textvariable=dt.in_adj, bd = 2).place(x = 150 , y = 169) 

cancella1 = Button(radice , text ="Cancella" ,width="15", bg="brown",command = cancella_1).place(x = 300, y = 69)
cancella2 = Button(radice , text ="Cancella" ,width="15", bg="azure",command = cancella_2).place(x = 300, y = 119)

conferma1 = Button(radice , text ="Conferma Taglio" ,width="15", bg="yellow",command = estrai).place(x = 150, y = 250)
conferma2 = Button(radice , text ="Arresta  Taglio" ,width="15", bg="brown",command = estrai).place(x = 150, y = 300)

l4 = Label(radice,text ="Sto tagliando il Pz n° :",width ="20",bg = "white").place(x=260, y=200)
l5 = Label(radice,text = r ,width ="5",bg="yellow",font = "Times 14 normal").place(x=410, y=197) # correggere text

l6 = Label(radice,text ="by Pippo Elettronica",width ="20",font = "Times 10 normal").place(x=360, y=370)

radice.mainloop()


		
	

